%%%%%%%% Calcolo Derivate mediante differenze finite %%%%%%%%%
n=30;
x = linspace(-2,2,n); 
f = sin(x.^2); 
% 
subplot(3,1,1) 
plot(x,f,'k') 
title('La funzione f(x) = sin(x^2)') 
grid on 
hold on
% 

%calcolo della derivata prima 
%dx = x(2)-x(1) %
dx = diff(x); 
%vettore di n-1 valori! 
%df = diff(f); 
df = f(2:n)-f(1:n-1);  % differenze in avanti
Dfapp = df./dx; 
L=length(Dfapp); 
% 
subplot(3,1,2) 
plot(x(1:end -1),Dfapp ,'ro')
grid on; title('Df')
hold on 
% 

%calcolo della derivata seconda 
dx2 = dx.^2; 
%df2 = diff(f,2);
df2 = f(1:n-2)-2*f(2:n-1)+f(3:n);
%vettore di n-2 valori! 
D2fapp = df2./dx2(1:end -1); 
L2 = length(D2fapp); 
subplot(3,1,3) 
plot(x(2:end -1),D2fapp ,'go') 
grid on; title('D^2f')
hold on 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% calcolo simbolico
syms x 
f = sin(x.^2); 
disp('Data f: ') 
pretty(f) 
Df = diff(f); 
sDf = simplify(Df); 
disp('Df : ') 
pretty(sDf)

D2f = diff(f,'x',2); 
%derivata seconda  
sD2f = simplify(D2f); 
disp('D2_f: ') 
pretty(sD2f)

%% Grafico funzioni derivate esatte
% 
subplot(3,1,1) 
ezplot(f,[-2,2])  % f
subplot(3,1,2) 
ezplot(Df,[-2,2]) % Df = 2*cos(x.^2).*(x) 
subplot(3,1,3) 
ezplot(D2f,[-2,2])% D2f = 2*cos(x.^2)-4*x.^2.*sin(x.^2)

