clear all
close all
clc

%%%%%%%%%%%%%  punto A calcolo stima derivate prime 
%%%%%%%%%%%%%          con differenze finite 
der_ex=1/3;
x=sqrt(2);
h=1;
H=zeros(32,1);
err_rel=zeros(32,1);
%preallocazione  dei vettori x maggiore velocit esecutiva
for i=1:32
    h=h/2;
    H(i)=h;

    Der_h(i)=(atan(x+h)-atan(x-h))/(2*h);  
    Der_a(i)=(atan(x+h)-atan(x))/h;
    Der_i(i)=(atan(x)-atan(x-h))/h;
    
    err_rel_cent(i)=abs(Der_h(i)-der_ex)/der_ex;
    err_rel_avanti(i)=abs(Der_a(i)-der_ex)/der_ex;
    err_rel_indietro(i)=abs(Der_i(i)-der_ex)/der_ex;
    
end

figure
loglog(H,err_rel_avanti,'mo'),hold on;
loglog(H,err_rel_cent,'gp')
loglog(H,err_rel_indietro,'kp')

%%%%%%%%%%%%%  punto B Estrapolazione di Richardson 
h=1;
for i=1:32
    h=h/2;
    H(i)=h;

    Der_h(i)=(atan(x+h)-atan(x-h))/(2*h);  
    Der_hmezzi(i)=((atan(x+h/2)-atan(x-h/2))/h);

    E_Rich(i)=(4*Der_hmezzi(i)-Der_h(i))/3;
    
    err_rel_cent(i)=abs(Der_h(i)-der_ex)/der_ex;
    err_rel_Rich(i)=abs(E_Rich(i)-der_ex)/der_ex
end

figure(2)
loglog(H,err_rel_cent,'kp'),hold on;
loglog(H,err_rel_Rich,'gp');

format long
xlabel('Passo h');
ylabel('Errore relativo');
pause
display('Derivate mediante differenze centrali');
Derivate_diff=Der_h'
display('Derivate mediante estrapolazione di Richardson');
Derivate_Rich=E_Rich'
display('Passo h');
H